<?php

/**
 * @file
 * hook_file and torrentfield file functions.
 */

/**
 * Implementation of hook_file().
 */

//BUG: called not only when torrent-file is initially uploaded, but also reuploaded... (?)
function bt_torrent_file_insert($file) {
  if (bt_torrent_file_is_torrent($file)) {
    $file = (array)$file;
    
    $torrent = bdecode_file($file['filepath']);

    $fid = $file['fid'];

    // Insert the torrent info about its files into the database
    if (is_array($torrent['info']) && array_key_exists('files', $torrent['info'])) {
      foreach ($torrent['info']['files'] as $torrent_file) {
        list($file_path, $file_name) = torrent_compose_file_path_and_name($torrent_file['path']);
        db_query("INSERT INTO {bt_torrents_files}(fid, length, path, name) VALUES (%d, '%s', '%s', '%s')", $fid, $torrent_file['length'], $file_path, $file_name);
      }
    }
    else if (is_array($torrent['info'])) {
      db_query("INSERT INTO {bt_torrents_files}(fid, length, path, name) VALUES (%d, '%s', '%s', '%s')", $fid, $torrent['info']['length'], '', $torrent['info']['name']);
    }
    else {
      watchdog('BitTorrent Upload Error', 'User attempted to upload torrent with invalid info section.', WATCHDOG_ERROR);
    }

    $announcers = array();
    $announce_tier_list = torrent_get_announce_tier_list($torrent);
    foreach( $announce_tier_list as $announce_tier ) {
      $announcers = array_merge($announcers, $announce_tier);
    }

    db_query("INSERT INTO {bt_torrents}(fid, info_hash, announce_url, total_size) VALUES (%d, '%s', '%s', %d)", $fid, info_hash($torrent), serialize($announcers), torrent_calc_total_size($torrent));
  }
}

//BUG: called not only when torrent-file is reuploaded, but also at initial torrent-file upload... (?)
function bt_torrent_file_update($file) {
  if (bt_torrent_file_is_torrent($file)) {
    $file = (array)$file;
    
    $torrent = bdecode_file($file['filepath']);

    $fid = $file['fid'];

    // Update the torrent in the database
    db_query("DELETE FROM {bt_torrents_files} WHERE fid = %d", $fid);

    if (is_array($torrent['info']) && array_key_exists('files', $torrent['info'])) {
      foreach ($torrent['info']['files'] as $torrent_file) {
        list($file_path, $file_name) = torrent_compose_file_path_and_name($torrent_file['path']);
        db_query("INSERT INTO {bt_torrents_files}(fid, length, path, name) VALUES (%d, '%s', '%s', '%s')", $fid, $torrent_file['length'], $file_path, $file_name);
      }
    }
    elseif (is_array($torrent['info'])) {
      db_query("INSERT INTO {bt_torrents_files}(fid, length, path, name) VALUES (%d, '%s', '%s', '%s')", $fid, $torrent['info']['length'], '', $torrent['info']['name']);
    }
    else {
      watchdog('BitTorrent Upload Error', 'User attempted to upload torrent with invalid info section.', WATCHDOG_ERROR);
    }

    $announcers = array();
    $announce_tier_list = torrent_get_announce_tier_list($torrent);
    foreach( $announce_tier_list as $announce_tier ) {
      $announcers = array_merge($announcers, $announce_tier);
    }

    db_query("UPDATE {bt_torrents} SET info_hash = '%s', announce_url = '%s', total_size = %d WHERE fid = %d", info_hash($torrent), serialize($announcers), torrent_calc_total_size($torrent), $fid);
  }
}

function bt_torrent_file_delete($file) {
  if (bt_torrent_file_is_torrent($file))
  {
    $file = (array)$file;
    
    $fid = $file['fid'];

    db_query("DELETE FROM {bt_torrents} WHERE fid = %d", $fid);
    db_query("DELETE FROM {bt_torrents_files} WHERE fid = %d", $fid);
  }
}

/**
 * Private functions.
 */

// test if a file is a torrent.
function bt_torrent_file_is_torrent($file) {
  $file = (array)$file;

  return (($file['filemime'] == 'application/x-bittorrent') || (stripos($file['filename'], '.torrent') !== FALSE)); //???
}
